;Filename: UrtWrb.s
;Part    : ADuC703x.
;Created : 14/04/2006
;Author  : Patrick Noonan (Analog Device Inc.)
;This file is in beta sampling.

;This software is supplied subject our standard software license agreement.
;A non-binding summary is as follows:
;"You may use the software in your own code at your own risk.
;" ADI inc disclaims any warranty or liability of its use".
;The full standard software license agreement is available on request and
; remains the binding agreement.


#include        <ADuC7030.inc>

; UrtWrb==========UART data write.
; C Function prototype: int UrtWrb(unsigned char Tx);
;iTx:{}
; Description of Function: Writes 8 bits of iTx to the UART 
;   for transmission.
; User interface:
;   Put value to send in iTx.
;   Call UrtWrb will output iTx if TX registers not full already.
;   Returns 1 if successful or 0 if TX registers full already:
; Robustness:
;   UART must be configured before writing data.
;   Does not wait if UART full.
; Side effects: Corrupts r1 and r3.

                RSEG CODE
                MODULE UrtWrb
                PUBLIC UrtWrb
                CODE32

UrtWrb:
        mov     r3,#0xff0000            ;r3 = Z_BASE;
        orr     r3,r3,#0xff000000
        ldr     r1,[r3,#Z_COMSTA0]
        ands    r1,r1,#0x040            ;if(COMSTA.6) 
        strne   r0,[r3,#Z_COMTX]        ; { COMTX = iTx; r0 = 1; }
        movne   r0,#1
        moveq   r0,#0                   ;else r0 = 0;
        bx      lr

                 ENDMOD  UrtWrb

                 END
        
